



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>多线程系列之十：Future模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">多线程系列之十：Future模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 04:06:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一,Future模式</p>
<p>假设有一个方法需要花费很长的时间才能获取运行结果。那么，与其一直等待结果，不如先拿一张 提货单。获取提货单并不耗费时间。这里提货单就称为Future角色<br />获取Future角色的线程会在稍后使用Future角色来获取运行结果<br />在处理开始时先返回Future角色，等到其他线程出来终止后，在将结果设置到Future角色中。<br />二，示例程序</p>
<p>Data:访问数据的接口</p>
<p>RealData:实际处理数据的类</p>
<p>FutureData:表示RealData的提货单，</p>
<p>Host:先拿提货单future实例，开启新线程创建RealData实例</p>
<div>
<pre class="prettyprint linenums">public interface Data {

    public abstract String getContent();<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">public class RealData implements Data {<br />
    private final String content;

    public RealData(int count,char c){<br />
        System.out.println("   making RealData("+count+" , "+ c +") begin");<br />
        char[] buffer = new char[count];<br />
        for (int i = 0; i &lt;count ; i++) {<br />
            buffer[i] = c ;<br />
            try {<br />
                Thread.sleep(100);<br />
            }catch (InterruptedException e){

            }<br />
        }<br />
        System.out.println("   making RealData("+count+" , "+ c +") end");<br />
        this.content = new String(buffer);<br />
    }<br />
    @Override<br />
    public String getContent() {

        return content;<br />
    }

    @Override<br />
    public String toString() {<br />
        return "real.toString";<br />
    }<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">public class FutureData implements Data {<br />
    private RealData realData = null;

    private boolean ready = false;

    /**<br />
     * 为Future类中的字段设置值<br />
     * @param realData<br />
     */<br />
    public synchronized void setRealData(RealData realData) {<br />
        if(ready){<br />
            return;<br />
        }<br />
        this.realData = realData;<br />
        this.ready = true;<br />
        notifyAll();<br />
    }

    /**<br />
     * 还没有成功设置值之前 一直等待。设置成功后就返回值<br />
     * @return<br />
     */<br />
    @Override<br />
    public synchronized String getContent() {<br />
        while (!ready){<br />
            try {<br />
                wait();<br />
            }catch (InterruptedException e){

            }<br />
        }<br />
        return realData.getContent();<br />
    }

    @Override<br />
    public String toString() {<br />
        return "feature.toString";<br />
    }<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">public class Host {<br />
    public Data request(final int count, final char c){<br />
        System.out.println("    request("+count+" , "+c+") begin");<br />
        //1,创建FutureData实例<br />
        final FutureData futureData = new FutureData();<br />
        //2,启动一个新线程去创建RealData实例，耗时操作<br />
        new Thread(){<br />
            @Override<br />
            public void run() {<br />
                RealData realData = new RealData(count,c);<br />
                futureData.setRealData(realData);<br />
            }<br />
        }.start();<br />
        System.out.println("    request("+count+" , "+c+") end");

        //3,将Future实例作为返回值返回给调用者<br />
        return futureData;<br />
    }<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">public class Test {<br />
    public static void main(String[] args) {<br />
        System.out.println(" main begin ..........");<br />
        Host host = new Host();<br />
        Data data1 = host.request(10,'a');<br />
        System.out.println("虚拟数据：data1 = "+data1.toString());<br />
        Data data2 = host.request(20,'b');<br />
        System.out.println("虚拟数据：data2 = "+data2.toString());<br />
        Data data3 = host.request(30,'c');<br />
        System.out.println("虚拟数据：data3 = "+data3.toString());

        System.out.println(" main OtherJobs begin");<br />
        try {<br />
            //模拟主线程处理其他业务<br />
            Thread.sleep(2000);<br />
        }catch (InterruptedException e){

        }<br />
        System.out.println(" main OtherJobs end");

        System.out.println("真实数据：data1 = "+data1.getContent());<br />
        System.out.println("真实数据：data2 = "+data2.getContent());<br />
        System.out.println("真实数据：data3 = "+data3.getContent());

        System.out.println(" main end ..........");<br />
    }<br />
}</pre>
</div>
<p>三，特点</p>
<p>1,提高吞吐量<br />首先这种模式可以提高程序响应性，但是耗时的操作花费的时间并没有减少啊，当程序在进行磁盘读写时，cpu处于等待状态，这时可以把cpu分配给其他的线程，就可以提高吞吐量了</p>
<p>四，Callable和Future</p>
<div>
<pre class="prettyprint linenums">public class CallableAndFuture {<br />
    public static void main(String[] args) {

        ExecutorService threadPool= Executors.newSingleThreadExecutor();<br />
        /*<br />
        threadPool.submit()  返回有结果的<br />
         */

        Future&lt;String&gt; future=      //Future是用来接收submit的结果的。泛型和Callable的结果一样<br />
        threadPool.submit(new Callable&lt;String&gt;() {//这里泛型了，

            @Override<br />
            public String call() throws Exception {<br />
                Thread.sleep(1000);<br />
                System.out.println("处理结果中。。。。");<br />
                Thread.sleep(1000);<br />
                return "hello";<br />
            }<br />
        });<br />
        System.out.println("等待结果");<br />
        try {<br />
            System.out.println("拿到结果"+future.get());<br />
        } catch (InterruptedException e) {<br />
            e.printStackTrace();<br />
        } catch (ExecutionException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

}</pre>
</div>
<div>
<pre class="prettyprint linenums">/**<br />
 *<br />
 * CompletionService用于提交一组Callable任务，其task方法返回已完成的一个Callable任务对应的Future对象<br />
 */<br />
public class CallableAndFuture2 {<br />
    public static void main(String[] args) {<br />
        ExecutorService threadPool2= Executors.newFixedThreadPool(10);<br />
        CompletionService&lt;Integer&gt; completionService = new ExecutorCompletionService(threadPool2);<br />
        for (int i = 0; i &lt; 10; i++) {<br />
            final int seq = i;<br />
            completionService.submit(new Callable() {<br />
                @Override<br />
                public Integer call() throws Exception {<br />
                    Thread.sleep(new Random().nextInt(5000));<br />
                    return seq;<br />
                }<br />
            });<br />
        }<br />
        while (true){<br />
            try {<br />
                System.out.println(completionService.take().get());<br />
            } catch (InterruptedException e) {<br />
                e.printStackTrace();<br />
            } catch (ExecutionException e) {<br />
                e.printStackTrace();<br />
            }<br />
        }<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx57kd8.html">【MySQL】锁问题最佳实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jleneq.html">JS数组push会覆盖前面的数据问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pg6ez9.html">redis make时 提示 zmalloc&period;h&colon;50&colon;31&colon; error&colon; jemalloc&sol;jemalloc&period;h&colon;</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdlo3x8.html">retinajs 使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/495v2gzq.html">nyoj366&lowbar;D的小L&lowbar;字典序&lowbar;全排列</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p0eeyq.html">第二十一课：js属性操作的兼容性问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok4wy59.html">&lbrack;整理归档&rsqb;30 common tasks you perform using the GUI that you can do faster in Windows PowerShell</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmggvk9.html">TensorFlow深度学习笔记 循环神经网络实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x6lw08.html">用Meta 取消流量器缓存实现每次访问都刷新页面方便调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okxy519.html">&period;Net 类型、对象、线程栈、托管堆运行时的相互关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpp3kxq.html">Android开发学习总结（六）&mdash;&mdash; APK反编译（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppwnr9.html">Android Loader使用，屏幕解锁，重复荷载</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey5kmm9.html">BNU Online Judge-34976-数细菌</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mnkrn8.html">IP地址 A&bsol;B&bsol;C类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgre478.html">redis常见重要性能指标数据分析和相关问题解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zk3e19.html">【java】-- 线程池原理分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7omdne8.html">改变highCharts的X轴和Y轴的数据刻度</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmllj9.html">linq之group by 的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4rx0x9.html">java多线程系列14  设计模式 Master-Worker</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllxeg1q.html">kafka&plus;elk</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdwjgr79.html">Win10 C盘桌面文件右上方的两个蓝色箭头解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o14ld1q.html">详解PHP中的过滤器（Filter）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvnl038.html">java操作elasticsearch实现查询删除和查询所有</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvlx538.html">Socket实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjp0ze9.html">寒假训练&mdash;&mdash;搜索 K - Cycle</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyvn2mq.html">Linux之命令初识</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyk7619.html">&lbrack;matlab&rsqb; 8&period;蚁群算法解决TSP问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2ewjy9.html">文本分类实战（一）&mdash;&mdash; word2vec预训练词向量</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jpv0eq.html">day1 计算机组成、操作系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zykn0x9.html">010&lowbar;vim和python整合开发</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
